"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _antd = require("antd");

var _rForm = require("./../r-form");

var _rForm2 = _interopRequireDefault(_rForm);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Export = function (_React$Component) {
    (0, _inherits3["default"])(Export, _React$Component);

    function Export() {
        (0, _classCallCheck3["default"])(this, Export);

        var _this = (0, _possibleConstructorReturn3["default"])(this, (Export.__proto__ || Object.getPrototypeOf(Export)).apply(this, arguments));

        _this.state = {
            visible: false,
            formFields: {
                columnsType: "ALL",
                checkedColumnKeys: [],
                rangeType: "ALL"
            }
        };
        _this.handleToggleVisible = function () {
            _this.setState(function (_ref) {
                var visible = _ref.visible;
                return { visible: !visible };
            });
        };
        _this.handleExportSubmit = function () {
            var _this$props = _this.props,
                columns = _this$props.columns,
                onExport = _this$props.onExport;
            var formFields = _this.state.formFields;
            var columnsType = formFields.columnsType,
                checkedColumnKeys = formFields.checkedColumnKeys,
                rangeType = formFields.rangeType;

            var nxtCheckedColumnKeys = columnsType === "ALL" ? columns.map(function (_ref2) {
                var key = _ref2.key,
                    dataIndex = _ref2.dataIndex;
                return key || dataIndex;
            }) : checkedColumnKeys;
            var exportResult = onExport(nxtCheckedColumnKeys, rangeType);
            if (!exportResult) {
                return;
            }
            _this.handleToggleVisible(); // close the dialog window.
        };
        _this.handleFormValuesChange = function (_ref3) {
            var _ref4 = (0, _slicedToArray3["default"])(_ref3, 2),
                formItemId = _ref4[0],
                formFieldValue = _ref4[1];

            _this.setState(function (_ref5) {
                var formFields = _ref5.formFields;
                return {
                    formFields: (0, _extends4["default"])({}, formFields, (0, _defineProperty3["default"])({}, formItemId, formFieldValue))
                };
            });
        };
        _this.handleOneClickExport = function () {
            _this.props.onExport();
        };
        return _this;
    }

    (0, _createClass3["default"])(Export, [{
        key: "render",
        value: function render() {
            var _props = this.props,
                locale = _props.locale,
                exportType = _props.exportType;

            if (exportType === "by-one-click") {
                return React.createElement(
                    _antd.Button,
                    { onClick: this.handleOneClickExport },
                    locale.exportBtnText
                );
            }
            var _props2 = this.props,
                exportOptions = _props2.exportOptions,
                columns = _props2.columns;
            var configModalTitle = exportOptions.configModalTitle,
                configModalPrev = exportOptions.configModalPrev,
                configModalExtra = exportOptions.configModalExtra;
            var _state = this.state,
                visible = _state.visible,
                formFields = _state.formFields;

            return React.createElement(
                "div",
                { style: { display: "inline-block" } },
                React.createElement(
                    _antd.Button,
                    { onClick: this.handleToggleVisible },
                    locale.exportBtnText
                ),
                React.createElement(
                    _antd.Modal,
                    { title: configModalTitle || locale.exportBtnText, footer: null, visible: visible, onCancel: this.handleToggleVisible },
                    configModalPrev,
                    React.createElement(_rForm2["default"], { style: {
                            minWidth: 500,
                            maxWidth: "75%"
                        }, onValuesChange: this.handleFormValuesChange, footer: {
                            defaultActionSpan: 20,
                            defaultActionOffset: 4,
                            submitText: locale.exportModal.submitText,
                            onSubmit: this.handleExportSubmit
                        }, formItems: [{
                            itemSpan: 24,
                            decorate: true,
                            decoratorOptions: {
                                initialValue: formFields.columnsType
                            },
                            id: "columnsType",
                            label: locale.columnsType.text,
                            control: React.createElement(_antd.Radio.Group, { options: [{ label: locale.columnsType.all, value: "ALL" }, { label: locale.columnsType.partial, value: "PARTIAL" }] })
                        }, {
                            visible: formFields.columnsType === "PARTIAL",
                            itemSpan: 24,
                            decorate: true,
                            id: "checkedColumnKeys",
                            label: " ",
                            colon: false,
                            control: React.createElement(_antd.Checkbox.Group, { options: columns.map(function (_ref6) {
                                    var title = _ref6.title,
                                        key = _ref6.key,
                                        dataIndex = _ref6.dataIndex;
                                    return {
                                        label: title,
                                        value: key || dataIndex
                                    };
                                }) })
                        }, {
                            itemSpan: 24,
                            decorate: true,
                            decoratorOptions: {
                                initialValue: formFields.rangeType
                            },
                            id: "rangeType",
                            label: locale.rangeType.text,
                            control: React.createElement(_antd.Radio.Group, { options: [{ label: locale.rangeType.all, value: "ALL" }, { label: locale.rangeType.selected, value: "SELECTED" }] })
                        }] }),
                    configModalExtra
                )
            );
        }
    }]);
    return Export;
}(React.Component);

exports["default"] = Export;
module.exports = exports["default"];