"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RTable = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require("react-dom");

var _lodash = require("lodash.omit");

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

var _antd = require("antd");

var _util = require("./../__util");

var _export = require("./export");

var _export2 = _interopRequireDefault(_export);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};

var defaultLocale = {
    editColumnsBtnText: "列设置",
    exportBtnText: "导出",
    exportModal: {
        submitText: "提交"
    },
    columnsType: {
        text: "列名",
        all: "全部",
        partial: "部分"
    },
    rangeType: {
        text: "范围",
        all: "全部记录",
        selected: "选中记录"
    },
    prevNext: {
        prevText: "上一页",
        nextText: "下一页"
    }
};
// tslint:disable-next-line:no-empty
var noop = function noop() {};
var hasFixedColumn = function hasFixedColumn() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.some(function (_ref) {
        var fixed = _ref.fixed;
        return !!fixed;
    });
};
var mapColumns = function mapColumns() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.map(function (column) {
        var _column$tooltip = column.tooltip,
            tooltip = _column$tooltip === undefined ? false : _column$tooltip,
            renderTooltip = column.renderTooltip,
            maxWidth = column.maxWidth,
            width = column.width,
            render = column.render;

        if (!tooltip) return column;
        if (!width && !maxWidth) {
            throw new Error("Ops, width or maxWidth is required when you need wrap tooltip!");
        }
        var nextColumn = (0, _extends3["default"])({}, column, { render: (0, _util.wrapTooltip)({
                maxWidth: Number(maxWidth || width) - 20,
                preRender: render,
                renderTooltip: renderTooltip
            }) });
        return (0, _lodash2["default"])(nextColumn, ["maxWidth", "tooltip", "renderTooltip"]);
    });
};
var removeColumnFixedProps = function removeColumnFixedProps() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    if (!hasFixedColumn(columns)) return columns;
    return columns.map(function (column) {
        if ("fixed" in column) {
            return (0, _lodash2["default"])(column, ["fixed"]);
        }
        return column;
    });
};
var scrollX = function scrollX(props, state) {
    var _props$columns = props.columns,
        columns = _props$columns === undefined ? [] : _props$columns,
        rowSelection = props.rowSelection,
        expandedRowRender = props.expandedRowRender;
    var invisibleColumnKeys = state.invisibleColumnKeys;

    var cols = columns.filter(function (column) {
        return !invisibleColumnKeys.includes(column.key || column.dataIndex);
    });
    // const hasFixedColumn = columns.some(({ fixed }) => !!fixed);
    if (!hasFixedColumn(cols)) return;
    var hasCheckbox = false;
    if ((typeof rowSelection === "undefined" ? "undefined" : (0, _typeof3["default"])(rowSelection)) == "object" && rowSelection) hasCheckbox = true;
    var initalWidth = 0;
    if (hasCheckbox) initalWidth += 62;
    if (typeof expandedRowRender == "function") initalWidth += 50;
    var unFixedColumnWidthSum = cols.reduce(function (widthSum, _ref2) {
        var _ref2$width = _ref2.width,
            width = _ref2$width === undefined ? 0 : _ref2$width;
        return widthSum + Number(width);
    }, initalWidth);
    // console.log(unFixedColumnWidthSum);
    return unFixedColumnWidthSum;
};
function getCheckedColumnOrColumnKeys() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var rtvType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "columnKeys";

    var visibleColumns = columns.map(function (_a) {
        var visible = _a.visible,
            _a$defaultVisible = _a.defaultVisible,
            defaultVisible = _a$defaultVisible === undefined ? true : _a$defaultVisible,
            rest = __rest(_a, ["visible", "defaultVisible"]);

        var columnVisible = typeof visible == "boolean" ? visible : defaultVisible;
        return (0, _extends3["default"])({ visible: columnVisible }, rest);
    }).filter(function (_ref3) {
        var visible = _ref3.visible;
        return visible;
    }).map(function (column) {
        return (0, _lodash2["default"])(column, ["visible"]);
    });
    if (rtvType === "columns") {
        return visibleColumns;
    } else if (rtvType === "columnKeys") {
        return visibleColumns.map(function (_ref4) {
            var key = _ref4.key,
                dataIndex = _ref4.dataIndex;
            return key || dataIndex;
        });
    }
    return []; // you pass the incorrect `rtvType`
}

var RTable = exports.RTable = function (_Component) {
    (0, _inherits3["default"])(RTable, _Component);

    function RTable() {
        (0, _classCallCheck3["default"])(this, RTable);

        var _this = (0, _possibleConstructorReturn3["default"])(this, (RTable.__proto__ || Object.getPrototypeOf(RTable)).apply(this, arguments));

        _this.state = {
            shouldRemoveColumnFixedProps: false,
            invisibleColumnKeys: []
        };
        _this.getPagination = function () {
            var pagination = _this.props.pagination;

            if (typeof pagination == "boolean") {
                return pagination;
            }
            if (!pagination) {
                return false;
            }
            var type = pagination.type;

            if (type === "prev_next") {
                return false;
            }
            return (0, _extends3["default"])({ showSizeChanger: true, pageSizeOptions: ["6", "10", "20", "50", "100", "500", "1000"], showQuickJumper: true, showTotal: function showTotal(total, _ref5) {
                    var _ref6 = (0, _slicedToArray3["default"])(_ref5, 2),
                        start = _ref6[0],
                        end = _ref6[1];

                    return start + "-" + end + " / " + total;
                } }, (0, _lodash2["default"])(pagination, ["onPrevClick", "onNextClick"]));
        };
        _this.fixColumnFixed = function () {
            var tableDomNode = (0, _reactDom.findDOMNode)(_this.table);
            var xWidth = scrollX(_this.props, _this.state) || 0;
            if (tableDomNode.clientWidth - xWidth > 0) {
                _this.setState({ shouldRemoveColumnFixedProps: true });
            }
        };
        _this.handleCheckedColumnKeysChange = function (checked, curColumnKey) {
            return function () {
                _this.setState(function (_ref7) {
                    var invisibleColumnKeys = _ref7.invisibleColumnKeys;

                    var nxtVisibleColumnKeys = !checked ? [].concat((0, _toConsumableArray3["default"])(invisibleColumnKeys), [curColumnKey]) : invisibleColumnKeys.filter(function (k) {
                        return k != curColumnKey;
                    });
                    return { invisibleColumnKeys: nxtVisibleColumnKeys };
                });
                _this.fixColumnFixed();
            };
        };
        _this.renderEditColumnsAction = function () {
            var showEditColumns = _this.props.showEditColumns;

            if (!showEditColumns) {
                return null;
            }
            var columns = _this.props.columns;
            var invisibleColumnKeys = _this.state.invisibleColumnKeys;

            var mapColumnsCheckbox = function mapColumnsCheckbox(_ref8) {
                var key = _ref8.key,
                    dataIndex = _ref8.dataIndex,
                    title = _ref8.title;

                var columnKey = key || dataIndex;
                var checked = !invisibleColumnKeys.includes(columnKey);
                return _react2["default"].createElement(
                    "p",
                    { key: columnKey },
                    _react2["default"].createElement(
                        _antd.Checkbox,
                        { checked: checked, value: columnKey, onChange: _this.handleCheckedColumnKeysChange(!checked, columnKey) },
                        title
                    )
                );
            };
            var columnsCheckboxGroup = _react2["default"].createElement(
                "div",
                null,
                columns.map(mapColumnsCheckbox)
            );
            var locale = _this.getLocale();
            return _react2["default"].createElement(
                _antd.Popover,
                { placement: "bottom", trigger: "click", content: columnsCheckboxGroup },
                _react2["default"].createElement(
                    _antd.Button,
                    null,
                    locale.editColumnsBtnText
                )
            );
        };
        _this.renderExportAction = function () {
            var _this$props = _this.props,
                showExport = _this$props.showExport,
                exportOptions = _this$props.exportOptions;

            if (!showExport) {
                return null;
            }
            var _this$props2 = _this.props,
                columns = _this$props2.columns,
                _this$props2$exportTy = _this$props2.exportType,
                exportType = _this$props2$exportTy === undefined ? "by-one-click" : _this$props2$exportTy,
                _this$props2$onExport = _this$props2.onExport,
                onExport = _this$props2$onExport === undefined ? noop : _this$props2$onExport;

            var locale = _this.getLocale();
            return _react2["default"].createElement(_export2["default"], { exportOptions: exportOptions, locale: locale, columns: columns, exportType: exportType, onExport: onExport });
        };
        _this.renderCardTitle = function () {
            return _this.props.cardTitle;
        };
        _this.renderCardExtra = function () {
            var prefixCls = _this.props.prefixCls;

            return _react2["default"].createElement(
                "div",
                { className: prefixCls + "--card-extra" },
                _this.renderEditColumnsAction(),
                _this.renderExportAction()
            );
        };
        _this.onPrevClick = function () {
            var _this$props$paginatio = _this.props.pagination,
                _this$props$paginatio2 = _this$props$paginatio.current,
                current = _this$props$paginatio2 === undefined ? 1 : _this$props$paginatio2,
                pageSize = _this$props$paginatio.pageSize,
                onPrevClick = _this$props$paginatio.onPrevClick;
            // if it is 1st page, we should stop here

            if (current === 1 || typeof onPrevClick != "function") {
                return;
            }
            onPrevClick(current - 1, pageSize);
        };
        _this.onNextClick = function () {
            var _this$props$paginatio3 = _this.props.pagination,
                _this$props$paginatio4 = _this$props$paginatio3.current,
                current = _this$props$paginatio4 === undefined ? 1 : _this$props$paginatio4,
                pageSize = _this$props$paginatio3.pageSize,
                onNextClick = _this$props$paginatio3.onNextClick;

            if (typeof onNextClick != "function") {
                return;
            }
            onNextClick(current + 1, pageSize);
        };
        _this.renderPrevNextAction = function () {
            var _this$props$paginatio5 = _this.props.pagination,
                _this$props$paginatio6 = _this$props$paginatio5.type,
                type = _this$props$paginatio6 === undefined ? "default" : _this$props$paginatio6,
                current = _this$props$paginatio5.current;

            if (type === "default") {
                return null;
            }
            var prefixCls = _this.props.prefixCls;

            var containerClazz = (0, _classnames2["default"])(prefixCls, prefixCls + "--prev-next-container");
            var btnsWrapperClazz = (0, _classnames2["default"])(prefixCls + "--prev-next-btns-wrapper");

            var _this$getLocale = _this.getLocale(),
                prevNext = _this$getLocale.prevNext;

            return _react2["default"].createElement(
                "div",
                { className: containerClazz },
                _react2["default"].createElement(
                    "div",
                    { className: btnsWrapperClazz },
                    _react2["default"].createElement(
                        _antd.Button,
                        { disabled: current === 1, onClick: _this.onPrevClick },
                        _react2["default"].createElement(_antd.Icon, { type: "left" }),
                        prevNext.prevText
                    ),
                    _react2["default"].createElement(
                        _antd.Button,
                        { onClick: _this.onNextClick },
                        prevNext.nextText,
                        _react2["default"].createElement(_antd.Icon, { type: "right" })
                    )
                )
            );
        };
        return _this;
    }

    (0, _createClass3["default"])(RTable, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            this.fixColumnFixed();
        }
    }, {
        key: "getLocale",
        value: function getLocale() {
            var locale = {};
            if (this.context.antLocale && this.context.antLocale.Table) {
                locale = this.context.antLocale.Table;
            }
            return (0, _extends3["default"])({}, defaultLocale, locale, this.props.locale);
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var _a = this.props,
                _a$showEditColumns = _a.showEditColumns,
                showEditColumns = _a$showEditColumns === undefined ? false : _a$showEditColumns,
                _a$showExport = _a.showExport,
                showExport = _a$showExport === undefined ? false : _a$showExport,
                _a$fixedMaxWidth = _a.fixedMaxWidth,
                fixedMaxWidth = _a$fixedMaxWidth === undefined ? false : _a$fixedMaxWidth,
                cardTitle = _a.cardTitle,
                prefixCls = _a.prefixCls,
                style = _a.style,
                scroll = _a.scroll,
                columns = _a.columns,
                others = __rest(_a, ["showEditColumns", "showExport", "fixedMaxWidth", "cardTitle", "prefixCls", "style", "scroll", "columns"]);var _state = this.state,
                shouldRemoveColumnFixedProps = _state.shouldRemoveColumnFixedProps,
                invisibleColumnKeys = _state.invisibleColumnKeys;

            var visibleColumns = getCheckedColumnOrColumnKeys(columns, "columns");
            var nextColumns = mapColumns(visibleColumns).filter(function (column) {
                return !invisibleColumnKeys.includes(column.key || column.dataIndex);
            });
            if (shouldRemoveColumnFixedProps) {
                nextColumns = removeColumnFixedProps(nextColumns);
            }
            var rest = (0, _lodash2["default"])(others, ["columns", "pagination"]);
            if (!others.rowKey) {
                rest = (0, _extends3["default"])({}, rest, { dataSource: (0, _util.insertIndexAsKey)(others.dataSource) });
            }
            var xWidth = scrollX(this.props, this.state);
            var defaultStyle = fixedMaxWidth ? { maxWidth: xWidth || "100%" } : {};
            var table = _react2["default"].createElement(
                "div",
                null,
                _react2["default"].createElement(_antd.Table, (0, _extends3["default"])({ ref: function ref(tableRef) {
                        return _this2.table = tableRef;
                    }, style: (0, _extends3["default"])({}, style, defaultStyle), size: "middle", columns: nextColumns, pagination: this.getPagination(), scroll: (0, _extends3["default"])({ x: xWidth }, scroll) }, rest)),
                this.renderPrevNextAction()
            );
            if (!cardTitle && !showEditColumns && !showExport) {
                return table;
            }
            return _react2["default"].createElement(
                _antd.Card,
                { className: prefixCls + "--card", bodyStyle: { padding: 0 }, bordered: false, noHovering: true, title: this.renderCardTitle(), extra: this.renderCardExtra() },
                table
            );
        }
    }]);
    return RTable;
}(_react.Component);

RTable.defaultProps = {
    exportOptions: {
        enabled: false,
        clickType: "default"
    },
    prefixCls: "r-antd_table",
    columns: []
};
RTable.contextTypes = {
    antLocale: _propTypes2["default"].object
};
exports["default"] = RTable;